
#include "stm32f10x_conf.h"
#include <stdio.h>


void USART_Configuration( void );


void Delay(volatile unsigned long delay)
{ 
	while(delay) delay--;
}


/*************************************************************************
 * Function Name: main
 * Parameters: none
 * Return: Int32U
 *
 * Description: The main subroutine
 * R̐ԊO󂯂āAԃf[^teratermɏo͂B
 *************************************************************************/
int main(void)
{
	unsigned long i, max;
	unsigned long num;
	unsigned long on_time_data[4800];
	unsigned long off_time_data[4800];
	unsigned int timerValue;
	unsigned int portA0;
	unsigned int portA1;

	// VXe܂iOONɂ72MHzɐ؂ւ܂j
	SystemInit();

	GPIO_init();
	InitializeTimer();

	USART_Configuration();
//	NVIC_Configuration();


//	USART_SendString("Hello STBEE\r\n");	//ÂBprintfg悤ɂ̂ŁAsvB
	lprintf("Remocon time measurement\n");

//ڈBLED_łB
#if 0
	for(i=0; i<5; i++){
		GPIO_ResetBits(GPIOD, _BV(4));
	    Delay(1000000);
		GPIO_SetBits(GPIOD, _BV(4));
	    Delay(2000000);
	}
#endif


//		TIM_SetCounter(TIM2, 0x0000);
//		lprintf("%d 0x%X\n",  TIM_GetCounter(TIM2),  TIM_GetCounter(TIM2));

		// push sw@ꂪꂽ瑪~āA擾f[^teratermɏo͂B
    	portA0 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_0);

		// ԊOȐo͂ɐڑĂB
    	portA1 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_1);		// PA1

	while(1){
		// R̐ԊOM҂
		lprintf("Now waiting remocon.\n");

		portA0 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_0);		// push sw
		portA1 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_1);		// PA1


		// ŏ̃ZT[LOWo͑҂ApushSWĂB
		while( portA1==1 && portA0==0 ){	// waiting sensor output = L (on)
			portA1 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_1);		// PA1
	    	portA0 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_0);		// push sw
		}


		for( i=0 ; i<(4800) ; i++ ){
			TIM_SetCounter(TIM2, 0x0000);	//^C}[ONA
			portA0 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_0);		// push sw
			portA1 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_1);		// PA1

			// ZT[HIGHo͑҂ApushSWĂB
			while( portA1==0 && portA0==0 ){	// waiting sensor output= H (off)
				portA1 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_1);		// PA1
		    	portA0 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_0);		// push sw
			}
			// ZT[LOWo͂̎Ԃzɕۑ
			on_time_data[i]=TIM_GetCounter(TIM2);	// sensor Low time

			TIM_SetCounter(TIM2, 0x0000);	//^C}[ONA
			portA0 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_0);		// push sw
			portA1 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_1);		// PA1

			// ZT[LOWo͑҂ApushSWĂB
			while( portA1==1 && portA0==0 ){	// waiting sensor output = L (on)
				portA1 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_1);		// PA1
		    	portA0 = GPIO_ReadInputDataBit (GPIOA, GPIO_Pin_0);		// push sw
			}
			// ZT[HIGHo͂̎Ԃzɕۑ
			off_time_data[i]=TIM_GetCounter(TIM2);	// sensor High time

			// pushSWĂ烋[v𔲂
			if( portA0==1 ){
				max=i;
				break;
			}
		}	// end of for



		lprintf("max value = %d\n", max);
		lprintf("Low   High  (sensor output) \n");

		for( i=0 ; i<max ; i++ ){
			lprintf("%d  %d\n", on_time_data[i],  off_time_data[i]);
		}

		lprintf("End of data\n\n\n");

	}	// end of while



	// GPIORg[֐gȂ炱̂悤ɂȂ܂B
	while(1){
		GPIO_ResetBits(GPIOD, _BV(4));
	    Delay(400000);
		GPIO_SetBits(GPIOD, _BV(4));
	    Delay(200000);
	}


}

//-----------------------------------------------
void USART_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStruct;
  USART_InitTypeDef USART_InitStruct;
  USART_ClockInitTypeDef USART_ClockInitStruct;

  /* oXNbNݒ */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO | RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1, ENABLE);

  /* GPIOݒ */
  GPIO_StructInit(&GPIO_InitStruct);
  GPIO_InitStruct.GPIO_Pin   = GPIO_Pin_9;
  GPIO_InitStruct.GPIO_Mode  = GPIO_Mode_AF_PP;
  GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStruct);

  GPIO_InitStruct.GPIO_Pin  = GPIO_Pin_10;
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOA, &GPIO_InitStruct);

  /* USARTݒ */
  USART_ClockStructInit(&USART_ClockInitStruct);
  USART_ClockInitStruct.USART_Clock = USART_Clock_Enable;
  USART_ClockInit(USART1, &USART_ClockInitStruct);

  USART_DeInit(USART1);
  USART_StructInit(&USART_InitStruct);
  USART_InitStruct.USART_BaudRate            = 9600;
  USART_InitStruct.USART_WordLength          = USART_WordLength_8b;
  USART_InitStruct.USART_Parity              = USART_Parity_No;
  USART_InitStruct.USART_StopBits            = USART_StopBits_1;
  USART_InitStruct.USART_Mode                = USART_Mode_Tx | USART_Mode_Rx;
  USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_Init(USART1, &USART_InitStruct);

  USART_Cmd(USART1, ENABLE);
}


//-----------------------------------------------
void InitializeTimer()
{
	// SYSCLK=72MHz
	// PCLK1=36MHz
	// TIM2CLK=72MHz
	// 1/72MHz x 72 = 1usec
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);

    TIM_TimeBaseInitTypeDef timerInitStructure; 
    timerInitStructure.TIM_Prescaler = 72;
    timerInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    timerInitStructure.TIM_Period = 0xFFFF;
    timerInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    timerInitStructure.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM2, &timerInitStructure);
    TIM_Cmd(TIM2, ENABLE);
}


//-----------------------------------------------
void GPIO_init( void ){

	GPIO_InitTypeDef GPIO_InitStruct;

	// GPIO D|[gLɂ܂
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);
	
	// PD.4|[go͂ɂ܂BPD.4=LED Lowœ_
	GPIO_InitStruct.GPIO_Pin		= _BV(4);
	GPIO_InitStruct.GPIO_Mode		= GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Speed		= GPIO_Speed_50MHz;
	GPIO_Init(GPIOD, &GPIO_InitStruct);	// ֐ǂݏo܂B


	RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA, ENABLE );
	GPIO_InitStruct.GPIO_Pin  = GPIO_Pin_0;
	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStruct);
}


#if 0
//-----------------------------------------------
/* 荞݂̐ݒs֐ */
void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStruct;

  /* USARTM荞ݐݒ */
  NVIC_InitStruct.NVIC_IRQChannel                   = USART1_IRQn;
  NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStruct.NVIC_IRQChannelSubPriority        = 0;
  NVIC_InitStruct.NVIC_IRQChannelCmd                = ENABLE;
  NVIC_Init(&NVIC_InitStruct);

  USART_ClearITPendingBit(USART1, USART_IT_RXNE);
  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
}
//-----------------------------------------------
/*
  USARTM 荞݃nh
  MGR[ĕԂ
*/
void USART1_IRQHandler(void)
{
  char data;

	if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)
  {
    data = (char)USART_ReceiveData(USART1);
    if (data == '\r') {
      USART_SendString("\r\n");
    } else {
      USART_SendChar(data);
    }
  }
}
#endif



